config/routes.rb
Rails.application.routes.draw do

  match 'registration/start', via: [:get, :post, :put]
  match 'registration/register', via: [:get, :post]
  match 'registration/wei_register', via: [:get, :post]
  get 'registration/questions'
  post 'registration/pay'
  match 'registration/card', via: [:get, :post]
  get 'registration/details'

  ActiveAdmin.routes(self)

  resources :students do
    member do
      patch :card
    end
    resources :memberships, only: [:index]
    resources :payments, only: [:create, :update, :index]
  end

  resources :payments, only: [:index, :logs]
  get 'payments/logs', controller: 'payments', action: 'logs', as: :logs
  get 'payments/stats', controller: 'payments', action: 'stats', as: :trezo_stats

  scope 'wei' do
    resources :wei_registrations do
      member do
        post 'pay', as: :pay
      end
      collection do
        get 'waiting'
        get 'deposit'
        get 'registered'
        get 'unregistered'
        get 'to_refund'
        get 'parental'
      end
    end
    resources :wei_bungalows
    resources :wei_buses
  end

  get 'email/:key' => 'email#show', as: :view_email
  get 'email' => 'email#show' unless Rails.env.production?

  devise_for :users, :controllers => { :omniauth_callbacks => "users/omniauth_callbacks" }

  namespace :api, default: {format: :json}, path: '/api' do
    scope module: :version1 do
      match '*path', :controller => 'api', :action => 'cors', via: [:options]
      get 'auth' => 'api#auth'
      get 'membership' => 'membership#show'
      get 'students' => 'membership#index'
      get 'mass_students' => 'membership#bulk'
    end
  end

  root 'students#index'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/controllers/wei_buses_controller.rb
class WeiBusesController < ApplicationController
  before_action :set_wei_bus, only: [:show, :edit, :update, :destroy]

  # GET /wei_buses
  # GET /wei_buses.json
  def index
    @wei_buses = WeiBus.all
  end

  # GET /wei_buses/1
  # GET /wei_buses/1.json
  def show
  end

  # GET /wei_buses/new
  def new
    @wei_bus = WeiBus.new
  end

  # GET /wei_buses/1/edit
  def edit
  end

  # POST /wei_buses
  # POST /wei_buses.json
  def create
    @wei_bus = WeiBus.new(wei_bus_params)

    respond_to do |format|
      if @wei_bus.save
        format.html { redirect_to @wei_bus, notice: 'Wei bus was successfully created.' }
        format.json { render :show, status: :created, location: @wei_bus }
      else
        format.html { render :new }
        format.json { render json: @wei_bus.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /wei_buses/1
  # PATCH/PUT /wei_buses/1.json
  def update
    respond_to do |format|
      if @wei_bus.update(wei_bus_params)
        format.html { redirect_to @wei_bus, notice: 'Wei bus was successfully updated.' }
        format.json { render :show, status: :ok, location: @wei_bus }
      else
        format.html { render :edit }
        format.json { render json: @wei_bus.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /wei_buses/1
  # DELETE /wei_buses/1.json
  def destroy
    @wei_bus.destroy
    respond_to do |format|
      format.html { redirect_to wei_buses_url, notice: 'Wei bus was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_wei_bus
      @wei_bus = WeiBus.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def wei_bus_params
      params.require(:wei_bus).permit(:name, :seats)
    end
end

app/views/wei_buses/_form.html.haml
= form_for(wei_bus) do |f|

  .row
    .col-md-7{class: [bs_form_error_cl(f,:name)]}
      .form-group
        = f.label :name
        = f.text_field :name, class: 'form-control'
        = bs_form_errors(f, :name)
    .col-md-5{class: [bs_form_error_cl(f,:seats)]}
      .form-group
        = f.label :seats
        = f.number_field :seats, class: 'form-control'
        = bs_form_errors(f, :seats)
  .actions
    = f.submit class:'btn btn-block btn-primary'

app/views/wei_buses/edit.html.erb
<h1><%= t('.edit') %></h1>

<%= render 'form', wei_bus: @wei_bus %>

<%= link_to t('cancel'), wei_buses_path, class: %w(btn btn-secondary m-t-1 btn-block) %>

app/views/wei_buses/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Wei Buses</h1>

<table class="table table-bordered table-hover table-striped">
  <thead>
    <tr>
      <th><%= t('activerecord.attributes.wei_bus.name') %></th>
      <th><%= t('activerecord.attributes.wei_bus.seats') %></th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @wei_buses.each do |wei_bus| %>

      <tr>
        <td><%= wei_bus.name %></td>
        <td><%= wei_bus.students.count %>/<%= wei_bus.seats %></td>
        <td><%= link_to 'Show', wei_bus %></td>
        <td><%= link_to 'Edit', edit_wei_bus_path(wei_bus) %></td>
        <td><%= link_to 'Destroy', wei_bus, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to t('wei_buses.new.new'), new_wei_bus_path, class: %w(btn btn-success m-t-1 btn-block) %>

app/views/wei_buses/new.html.erb
<h1><%= t('.new') %></h1>

<%= render 'form', wei_bus: @wei_bus %>

<%= link_to t('cancel'), wei_buses_path, class: %w(btn btn-secondary m-t-1 btn-block) %>

app/views/wei_buses/show.html.haml
%h1= @wei_bus.name

%table#wei_bus.table.table-bordered
  - @wei_bus.students.each do |student|
    %tr.text-center
      %td= link_to student.name, student.wei_registrations.last
      %td
        = link_to "tel:#{student.phone}", class: 'tag tag-primary tag-pill' do
          .fa.fa-phone
          = student.phone.phony_formatted(format: :international, space: '-')
        %br
        = link_to "mailto:#{student.email}", class: 'tag tag-primary tag-pill' do
          .fa.fa-envelop
          = student.email

      %td
        = form_for student.wei_registrations.last, remote: true do |f|
          = f.hidden_field :wei_bus_id, value: nil
          = f.submit t('wei_registrations.show.unregister'), class: %w(btn btn-danger), data: {confirm: 'Le virer du bus ?'}